#!/usr/bin/perl -w

use strict;
use Tk;
use GD::Graph::bars;
#use Chart::Plot;
require Tk::Dialog;
require Tk::Jpeg;
#use Image::Magick;
#Tk objects
my ($Form1, $mmenubar, @mainmenu, $Label, $MeoteoriteBtt, $Graph, $StartBtt, $StopBtt, $Active, $AveMinTxt, $AveHourTxt, $CurrCountTxt);

#Variables
my ($currentFile, $currentCount, $startTime, $currentTime, $endTime, $totalTime, $analyizeCount, $currentAverageMin, $currentAverageHour,);
my ($currentCountTxt, $currentAverageMinTxt, $currentAverageHourTxt, $startFlag, $readbleTime, @meteoriteSeconds);


#set Variables
$currentCount = 0;
$currentAverageMin = 0;
$currentAverageHourTxt = 0;

$currentCountTxt = "Current Count $currentCount";
$currentAverageMinTxt = "Average $currentAverageMin per a minute";
$currentAverageHourTxt = "Average $currentAverageHour per a Hour";

$startFlag = 0;

#create form
$Form1 = MainWindow->new;
$Form1->title("MeteoriteCount");
$Form1->geometry("797x494+8+8");

#loadup images
$Form1-> Photo('redgif', 
             -file => "red.gif");
$Form1-> Photo('greengif', 
             -file => "green.gif");
$Form1-> Photo('graphgif', 
             -file => "graph.jpg");

$mmenubar = $Form1->Frame(-relief => 'raised', -borderwidth => 2, -height => 16)
->pack(-side => 'top', -anchor => 'n', -expand => 1, -fill => 'x');


push (@mainmenu, $mmenubar->Menubutton(-text => "File", -tearoff => 0, -menuitems => [ 
      ["command" => "Open", -font => "Arial 8 normal", ],
      ["command" => "Close", -font => "Arial 8 normal", ],
      ["command" => "Save", -font => "Arial 8 normal", ],
      ["command" => "Analysize", -font => "Arial 8 normal", ],
      ["command" => "Help", -font => "Arial 8 normal", ],
	  ["command" => "Exit", -font => "Arial 8 normal",-command =>\&ExitNow ]
]));
$mainmenu[0]->pack(-side => 'left');

$Label = $Form1->Label(
                        -text => "Data collection", 
                        -background => "#D4D0C8", 
                        -cursor => "", 
                        -font => "Tahoma 12 normal"
                        );


$Label->place(-width => 120, 
               -height => 24, 
               -x => 24, 
               -y => 64);

$MeoteoriteBtt = $Form1->Button(
                          -text => "Meteorite",
						  -command => \&Incomming,
                          -cursor => "", 
                          -font => "Tahoma 14 normal"
                          );


$MeoteoriteBtt->place(-width => 752, 
                -height => 216, 
                -x => 24, 
                -y => 264);

$Graph = $Form1->Label('-image' => 'graphgif');

#$Graph->configure(-image => 'graphgif');

$Graph->place(-width => 540, 
                -height => 210, 
                -x => 232, 
                -y => 40);

$StartBtt = $Form1->Button(
                          -text => "Start",
						  -command =>\&StartCount,
                          -cursor => "", 
                          -font => "Tahoma 8 normal"
                          );


$StartBtt->place(-width => 96, 
                -height => 24, 
                -x => 24, 
                -y => 104);

$StopBtt= $Form1->Button(
                          -text => "Stop",
						  -command =>\&StopCount,
                          -cursor => "", 
                          -font => "Tahoma 8 normal"
                          );


$StopBtt->place(-width => 96, 
                -height => 24, 
                -x => 24, 
                -y => 144);

$Active = $Form1->Label('-image' => 'redgif');

$Active->place(-width => 24, 
                -height => 24, 
                -x => 168, 
                -y => 64);


$AveMinTxt = $Form1->Label(
                           -textvariable => \$currentAverageMinTxt, 
                           -background => "#D4D0C8", 
                           -cursor => "", 
                           -font => "Tahoma 10 normal"
                           );


$AveMinTxt->place(-width => 199, 
                  -height => 21, 
                  -x => 16, 
                  -y => 192);

$AveHourTxt = $Form1->Label(
                            -textvariable => \$currentAverageHourTxt, 
                            -background => "#D4D0C8", 
                            -cursor => "", 
                            -font => "Tahoma 10 normal"
                            );


$AveHourTxt->place(-width => 200, 
                   -height => 24, 
                   -x => 16, 
                   -y => 216);

$CurrCountTxt = $Form1->Label(
                              -textvariable =>\$currentCountTxt, 
                              -background => "#D4D0C8", 
                              -cursor => "", 
                              -font => "Tahoma 10 normal"
                              );


$CurrCountTxt->place(-width => 200, 
                     -height => 16, 
                     -x => 16, 
                     -y => 240);

# Spin the message loop
MainLoop;

############################ SUBS ############################

sub ExitNow{
	
	exit;
}

sub Incomming {
	my ($incommingErrorText, $seconds);
	if ($startFlag == 1){
		$currentCount ++;
		$analyizeCount ++;
		$currentCountTxt = "Current Count $currentCount";
		$currentTime = time;
		print OUTPUT "$currentTime\n";
		$seconds = ($currentTime - $startTime);
		push (@meteoriteSeconds, $seconds,);
		&calculateAverages;
	}
	else {
		$incommingErrorText = "Start the timer first!";
		errorDialog ($incommingErrorText);
		return ();
	}
	if ($analyizeCount ==10){
		&generateGraph;
		$analyizeCount = 0;
	}
	return ();
}

sub StartCount {
	my ($startErrortText);
	if ($startFlag == 1){
		$startErrortText = "All ready started count!";
		&errorDialog ($startErrortText);
		return ();
	}
	#flag start
	$startFlag =1;
	$startTime = time;
	$currentCount =0;
	$analyizeCount =0;
	#make new filename
	$currentTime = time;
	#my @currentTime_split = split (/\s/, $currentTime);
	#my @time_split = split (/:/, $currentTime_split[3]);
	$currentFile = "Meteorite" . $startTime .".txt";
	open (OUTPUT, ">$currentFile")|| die "cant make new results file: $currentFile\n";
	$readbleTime = localtime($startTime);
	print OUTPUT "Meteorite Counter Data File\nStarted accustion on $readbleTime\n";
	$Active->configure(-image => 'greengif');

	#$Form1->update;
	return ();
}

sub StopCount {
	my ($stopErrortText, $readbleTime);
	if ($startFlag == 1){
		$startFlag = 0;
		$endTime = time;
		$readbleTime = localtime($endTime);
		print OUTPUT "Stopped accustion on $readbleTime\n";
		&calculateAverages;
		print OUTPUT "Total Count $currentCount over $totalTime seconds\n";
		print OUTPUT "Average $currentAverageMin per a minute\nAverage $currentAverageHour per a Hour\n";
		close OUTPUT || die "cant close new results: $currentFile\n";
		$Active->configure(-image => 'redgif');
		#$Form1->update;
		&generateGraph;
	}
	else {
		$stopErrortText = "Timmer already stopped or never started!";
		&errorDialog ($stopErrortText);
	}
	return ();
}

sub errorDialog {
	my ($errortext) = @_;
	my ( $popBadLoc);
	$popBadLoc = $Form1->Dialog(
				-popover=> undef,
				-text =>"$errortext" 
	);
	$popBadLoc ->Show;
	return ();
}

sub generateGraph{
	my ($img, @xdata, @ydata, $GDobject, $graph_tolerance_type, $lower_number, $endnumber, $meteorites_bin_ref, %meteorites_bin, $error);
	my (@count_sorted, $value, @seconds_bin_sorted, @data, $gd_finished, $meteorite_graph, $y_max_value );	
	
	#plot graph of bined errors for protein and matching masses
	#bin errors
	$graph_tolerance_type = "Da";
	$lower_number = 1;
	$endnumber = ($currentTime - $startTime);
	$error = 60;
	($meteorites_bin_ref) = BinMass (@meteoriteSeconds, $graph_tolerance_type, $error, $lower_number, $endnumber);
	%meteorites_bin = %{ $meteorites_bin_ref};
	#Generate the data array for the chart
	@count_sorted = sort by_keys keys(%meteorites_bin);
	#print "protein bin @pbin_sorted\n";
	foreach $value (@count_sorted){
		push (@seconds_bin_sorted, $meteorites_bin{$value });
	}
	@data = ([@count_sorted], [@seconds_bin_sorted]);
	
	#set graph parameters
	$meteorite_graph = GD::Graph::bars->new(540, 210);
	$meteorite_graph->set(
		 x_label           => 'seconds',
		 title             => "Meteorites Binned by seconds",
		 y_max_value       => $y_max_value,
		 y_tick_number     => 10,
		 y_label_skip      => 1
	);
	$gd_finished = $meteorite_graph->plot(\@data);
	#save graph to disk
	open(IMG, ">graph.jpg") or die $!;
	binmode IMG;
	print IMG $gd_finished->jpeg;
	close IMG|| die "Couldn't close bar chart!\n";
	
#	
#	
#	@xdata = qw( -3  -2  -1  0  1  2  3 );
#    @ydata = qw(  9   4   1  0  1  4  9 );
#    $img->setData (\@xdata, \@ydata, 'red solidline');
#	open (WR,'>graph.png') or die ("Failed to write file: $!");
#    binmode WR;            # for DOSish platforms
#    print WR $img->draw();
#    close WR;
#	## Create a new Image::Magick object
#	my $img_magick = new Image::Magick;
#	# Read in our image
#	$img_magick->Read("graph.png");
#	#$img_magick4->Set(density=>'540x210'); 
#	$img_magick->Write(filename => 'graph.jpg');
#	unlink ('graph.png');
	
	$Form1-> Photo('graphgif', 
             -file => "graph.jpg");
	$Graph->configure(-image => 'graphgif');
	return ();
}

sub calculateAverages {
	$totalTime = $currentTime - $startTime;
	$currentAverageMin = $currentCount /($totalTime / 60) ;
	$currentAverageHour = $currentCount/($totalTime / 3600) ;
	($currentAverageMin) = &number_split($currentAverageMin, 2);
	($currentAverageHour) = &number_split($currentAverageHour, 2);
	$currentCountTxt = "Current Count $currentCount";
	$currentAverageMinTxt = "Average $currentAverageMin per a minute";
	$currentAverageHourTxt = "Average $currentAverageHour per a Hour";
	return ();
}

sub number_split {
	my ( $number, $deciminal_places ) = @_;
	my @numsplit =  split (/\./,$number);
	if ($#numsplit == 1){
		$number = $numsplit[0] . "." . substr($numsplit[1],0,$deciminal_places);
	}
	else {
		#the .00 is important if you want to index in to a hash later when the value is 0.
		$number = $numsplit[0] . ".00";
	}
	return $number;
}

sub BinMass {
	#Input
	my @input = @_;
	my ( $tolerance_type, $tolerance_value, $lower_mass, $endmass, @mass_array, $mass_window, $upper_mass, $graph_value, $bin, $mass_out, $mass, %binhash, $i); 
	#pop out values from input list
	#print "$#input\n";
	$endmass= pop (@input);
	$lower_mass= pop (@input);
	$tolerance_value= pop (@input); 
	$tolerance_type = pop (@input);
	#remaining values are ppm values
	@mass_array = @input;
	@mass_array = sort {$a <=> $b}(@mass_array);
	#$lower_mass = 50;
	#$tolerance_type = "ppm";
	#print "tolerance type $tolerance_type\n";
	#print "tolerance value $tolerance_value\n";
	#print "start bin $lower_mass\n";
	#print "end bin $endmass\n";
	#print "number of masses to bin $#mass_array\n";
	#print "@mass_array\n";
	while ($lower_mass < $endmass){
		$mass_window = cal_mass_tolerance ($lower_mass, $tolerance_type, $tolerance_value );
		$upper_mass = $lower_mass + $mass_window;
		$graph_value = ($lower_mass + $upper_mass) /2;
		$bin =0;
		#print " mass win is $mass_window upper $upper_mass lower $lower_mass graph $graph_value\n";
		for  ($i = 1; $i <= $#mass_array; $i++){
			#print "$mass\n";
			$mass_out = shift (@mass_array);
	
			if ($mass_out < $lower_mass){next;}
				if ($mass_out > $upper_mass){
					unshift (@mass_array, $mass_out);
					last;
				}
				if ($mass_out >= $lower_mass){# &&  $mass < $upper_mass){
					if ($mass_out < $upper_mass){ 
						$bin ++;
						#print "We got a hit mass $mass_out lower $lower_mass upper $upper_mass bin $bin\n";
					}
				}
			}
			unless ($bin == 0){
				#print "$graph_value\t$bin\n";
				$binhash{$graph_value}= $bin;
			}
			$lower_mass = $upper_mass;
		}
		return 	(\%binhash);
}
sub cal_mass_tolerance {
	my $mass = $_[0];
	my $tolerance_type = $_[1];
	my $tolerance_value = $_[2];
	my $mass_tolarance = 0;
	if ($tolerance_type eq "ppm"){
		#calculate mass tolerance in ppm
		$mass_tolarance = (($tolerance_value/1e6) * $mass);
	}
	#if tolerance eq Da	
	elsif ($tolerance_type  eq "Da"){
		#use tolerance value 
		$mass_tolarance = $tolerance_value;
	}
	return $mass_tolarance;
}
sub by_keys {
	($a <=> $b)
}